% HMM's
%   HMM_Backward        - HMM backward algorithm
%   HMM_Boltzmann       - Find the transition matrices of an HMM using Boltzmann networks
%   HMM_Decoding        - Find probable states from the output of an HMM
%   HMM_Evaluation      - Find the probability of a finite state in a Markov chain
%   HMM_Forward         - HMM forward algorithm
%   HMM_Forward_backward- Forward-backward estimation algorithm
%   HMM_Generate        - Generate a sample output of an HMM 
%
% Optimization
%   Gradient_descent    - Find the minimum of a function using gradient descent
%   Newton_descent      - Find the minimum of a function using Newton descent
%   demo_fun            - A demo fun to minimize
%   Stochastic_regression - Perform stochastic regression for linear data
%
% Estimations:
%   mean_jackknife      - Estimate the mean using the Jackknife estimate
%   mean_bootstrap      - Estimate the mean using the bootstrap estimate
%   ROCC                - Generate the reciever operating characteristic curve
%   Sufficient_statistics - Find the sufficient statistics for common distributions
%
% Data reshaping
%   Bayesian_parameter_est       - Estimate the mean using the Bayesian parameter estimation for Gaussian mixture
%
% String algorithms
%   Bottom_Up_Parsing
%   Boyer_Moore_String_Matching
%   Edit_Distance
%   Grammatical_Inference
%   Naive_String_Matching
%
% Bayesian belief networks
%   Bayesian_Belief_Networks
